aboutsummaryrefslogtreecommitdiff
path: root/bash/bash_completion.d/path.bash
diff options
context:
space:
mode:
authorTom Ryder <tom@sanctum.geek.nz>2016-08-30 14:43:33 +1200
committerTom Ryder <tom@sanctum.geek.nz>2016-08-30 14:51:41 +1200
commit95c3c2daf1e63f02a37db0e003f01da788acfb7d (patch)
tree8d477a9d48f58b8100b34892478bdce619db4ee4 /bash/bash_completion.d/path.bash
parentNote broken mysql() (diff)
downloaddotfiles-95c3c2daf1e63f02a37db0e003f01da788acfb7d.tar.gz
dotfiles-95c3c2daf1e63f02a37db0e003f01da788acfb7d.zip
Handle empty filename completions better
Bash 4.4 hangs in an awkward way (probably outputting the literal null char in some unexpected context) without this; I'm not sure if this is a bug or whether it's just been tolerated behaviour until now.
Diffstat (limited to 'bash/bash_completion.d/path.bash')
-rw-r--r--bash/bash_completion.d/path.bash14
1 files changed, 9 insertions, 5 deletions
diff --git a/bash/bash_completion.d/path.bash b/bash/bash_completion.d/path.bash
index 60b36844..e0e7732d 100644
--- a/bash/bash_completion.d/path.bash
+++ b/bash/bash_completion.d/path.bash
@@ -19,6 +19,7 @@ _path() {
insert|append|check)
local dirname
while IFS= read -rd '' dirname ; do
+ [[ -n $dirname ]] || continue
COMPREPLY[${#COMPREPLY[@]}]=$dirname
done < <(
@@ -30,11 +31,14 @@ _path() {
dirnames=("${COMP_WORDS[COMP_CWORD]}"*/)
dirnames=("${dirnames[@]%/}")
- # Bail if no results to prevent empty output
- ((${#dirnames[@]})) || exit 1
-
- # Print results, quoted and null-delimited
- printf '%q\0' "${dirnames[@]}"
+ # Print quoted entries, null-delimited, if there was at
+ # least one; otherwise, just print a null character to stop
+ # this hanging in Bash 4.4
+ if ((${#dirnames[@]})) ; then
+ printf '%q\0' "${dirnames[@]}"
+ else
+ printf '\0'
+ fi
)
;;